Index: palm/trunk/SOURCE/pmc_parent_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_parent_mod.f90	(revision 2798)
+++ palm/trunk/SOURCE/pmc_parent_mod.f90	(revision 2801)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Introduce particle transfer in nested models.
+! 
+! 2718 2018-01-02 08:49:38Z maronga
 ! Corrected "Former revisions" section
 ! 
@@ -88,5 +91,5 @@
 !
 ! Parent part of Palm Model Coupler
-!-------------------------------------------------------------------------------!
+!------------------------------------------------------------------------------!
 
 #if defined( __parallel )
@@ -99,13 +102,13 @@
 #endif
     USE kinds
-    USE pmc_general,                                                            &
-        ONLY: arraydef, childdef, da_namedef, da_namelen, pedef,                &
+    USE pmc_general,                                                           &
+        ONLY: arraydef, childdef, da_namedef, da_namelen, pedef,               &
               pmc_g_setname, pmc_max_array, pmc_max_models, pmc_sort
 
-    USE pmc_handle_communicator,                                                &
-        ONLY: m_model_comm,m_model_rank,m_model_npes, m_to_child_comm,          &
+    USE pmc_handle_communicator,                                               &
+        ONLY: m_model_comm,m_model_rank,m_model_npes, m_to_child_comm,         &
               m_world_rank, pmc_parent_for_child
 
-    USE pmc_mpi_wrapper,                                                        &
+    USE pmc_mpi_wrapper,                                                       &
         ONLY: pmc_alloc_mem, pmc_bcast, pmc_time
 
@@ -120,6 +123,6 @@
    END TYPE childindexdef
 
-   TYPE(childdef), DIMENSION(pmc_max_models)       ::  children     !<
-   TYPE(childindexdef), DIMENSION(pmc_max_models)  ::  indchildren  !<
+   TYPE(childdef), DIMENSION(pmc_max_models),PUBLIC   ::  children     !<
+   TYPE(childindexdef), DIMENSION(pmc_max_models)     ::  indchildren  !<
 
    INTEGER ::  next_array_in_list = 0  !<
@@ -148,4 +151,5 @@
         MODULE PROCEDURE pmc_s_set_dataarray_2d
         MODULE PROCEDURE pmc_s_set_dataarray_3d
+        MODULE PROCEDURE pmc_s_set_dataarray_ip2d
     END INTERFACE pmc_s_set_dataarray
 
@@ -166,8 +170,13 @@
     END INTERFACE pmc_s_set_active_data_array
 
-    PUBLIC pmc_parentinit, pmc_s_clear_next_array_list, pmc_s_fillbuffer,       &
-           pmc_s_getdata_from_buffer, pmc_s_getnextarray,                       &
-           pmc_s_setind_and_allocmem, pmc_s_set_active_data_array,              &
-           pmc_s_set_dataarray, pmc_s_set_2d_index_list
+    INTERFACE pmc_s_get_child_npes
+        MODULE PROCEDURE pmc_s_get_child_npes
+    END INTERFACE pmc_s_get_child_npes
+
+    PUBLIC pmc_parentinit, pmc_s_clear_next_array_list, pmc_s_fillbuffer,      &
+           pmc_s_getdata_from_buffer, pmc_s_getnextarray,                      &
+           pmc_s_setind_and_allocmem, pmc_s_set_active_data_array,             &
+           pmc_s_set_dataarray, pmc_s_set_2d_index_list,                       &
+           pmc_s_get_child_npes
 
  CONTAINS
@@ -178,8 +187,8 @@
     IMPLICIT NONE
 
-    INTEGER ::  childid   !<
-    INTEGER ::  i         !<
-    INTEGER ::  j         !<
-    INTEGER ::  istat     !<
+    INTEGER(iwp) ::  childid   !<
+    INTEGER(iwp) ::  i         !<
+    INTEGER(iwp) ::  j         !<
+    INTEGER(iwp) ::  istat     !<
 
 
@@ -193,16 +202,16 @@
 !
 !--    Get rank and size
-       CALL MPI_COMM_RANK( children(childid)%model_comm,                        &
+       CALL MPI_COMM_RANK( children(childid)%model_comm,                       &
                            children(childid)%model_rank, istat )
-       CALL MPI_COMM_SIZE( children(childid)%model_comm,                        &
+       CALL MPI_COMM_SIZE( children(childid)%model_comm,                       &
                            children(childid)%model_npes, istat )
-       CALL MPI_COMM_REMOTE_SIZE( children(childid)%inter_comm,                 &
+       CALL MPI_COMM_REMOTE_SIZE( children(childid)%inter_comm,                &
                                   children(childid)%inter_npes, istat )
 
 !
 !--    Intra communicator is used for MPI_GET
-       CALL MPI_INTERCOMM_MERGE( children(childid)%inter_comm, .FALSE.,         &
+       CALL MPI_INTERCOMM_MERGE( children(childid)%inter_comm, .FALSE.,        &
                                  children(childid)%intra_comm, istat )
-       CALL MPI_COMM_RANK( children(childid)%intra_comm,                        &
+       CALL MPI_COMM_RANK( children(childid)%intra_comm,                       &
                            children(childid)%intra_rank, istat )
 
@@ -228,14 +237,14 @@
      IMPLICIT NONE
 
-     INTEGER, INTENT(IN)                    :: childid     !<
-     INTEGER, DIMENSION(:,:), INTENT(INOUT) :: index_list  !<
-
-     INTEGER ::  ian    !<
-     INTEGER ::  ic     !<
-     INTEGER ::  ie     !<
-     INTEGER ::  ip     !<
-     INTEGER ::  is     !<
-     INTEGER ::  istat  !<
-     INTEGER ::  n      !<
+     INTEGER(iwp), INTENT(IN)                    :: childid     !<
+     INTEGER(iwp), DIMENSION(:,:), INTENT(INOUT) :: index_list  !<
+
+     INTEGER(iwp) ::  ian    !<
+     INTEGER(iwp) ::  ic     !<
+     INTEGER(iwp) ::  ie     !<
+     INTEGER(iwp) ::  ip     !<
+     INTEGER(iwp) ::  is     !<
+     INTEGER(iwp) ::  istat  !<
+     INTEGER(iwp) ::  n,i    !<
 
 
@@ -268,12 +277,12 @@
               IF ( ian > 0)  THEN
                   ALLOCATE( indchildren(childid)%index_list_2d(6,ian) )
-                  indchildren(childid)%index_list_2d(:,1:ian) =                 &
+                  indchildren(childid)%index_list_2d(:,1:ian) =                &
                                                              index_list(:,is:ie)
               ENDIF
            ELSE
-              CALL MPI_SEND( ian, 1, MPI_INTEGER, ip, 1000, m_model_comm,       &
+              CALL MPI_SEND( ian, 1, MPI_INTEGER, ip, 1000, m_model_comm,      &
                              istat )
               IF ( ian > 0)  THEN
-                  CALL MPI_SEND( index_list(1,is), 6*ian, MPI_INTEGER, ip,      &
+                  CALL MPI_SEND( index_list(1,is), 6*ian, MPI_INTEGER, ip,     &
                                  1001, m_model_comm, istat )
               ENDIF
@@ -282,16 +291,16 @@
         ENDDO
      ELSE
-        CALL MPI_RECV( indchildren(childid)%nrpoints, 1, MPI_INTEGER, 0, 1000,  &
+        CALL MPI_RECV( indchildren(childid)%nrpoints, 1, MPI_INTEGER, 0, 1000, &
                        m_model_comm, MPI_STATUS_IGNORE, istat )
         ian = indchildren(childid)%nrpoints
         IF ( ian > 0 )  THEN
            ALLOCATE( indchildren(childid)%index_list_2d(6,ian) )
-           CALL MPI_RECV( indchildren(childid)%index_list_2d, 6*ian,            &
-                          MPI_INTEGER, 0, 1001, m_model_comm,                   &
+           CALL MPI_RECV( indchildren(childid)%index_list_2d, 6*ian,           &
+                          MPI_INTEGER, 0, 1001, m_model_comm,                  &
                           MPI_STATUS_IGNORE, istat)
         ENDIF
      ENDIF
-     CALL set_pe_index_list( childid, children(childid),                        &
-                             indchildren(childid)%index_list_2d,                &
+     CALL set_pe_index_list( childid, children(childid),                       &
+                             indchildren(childid)%index_list_2d,               &
                              indchildren(childid)%nrpoints )
 
@@ -313,7 +322,6 @@
 
 !
-!-- List handling is still required to get minimal interaction with
-!-- pmc_interface
-!-- TODO: what does "still" mean? Is there a chance to change this!
+!-- Althoug there are no linked lists any more in PMC, this call still looks like working with a list
+
     CHARACTER(LEN=*), INTENT(OUT) ::  myname    !<
     INTEGER(iwp), INTENT(IN)      ::  childid   !<
@@ -338,6 +346,6 @@
     myname = ar%name
 !
-!-- Return true if legal array
-!-- TODO: what does this comment mean? Can there be non-legal arrays??
+!-- Return true if there is still an array in the list
+
     pmc_s_getnextarray = .TRUE.
 
@@ -350,11 +358,11 @@
     IMPLICIT NONE
 
-    INTEGER,INTENT(IN) ::  childid   !<
+    INTEGER(iwp), INTENT(IN) ::  childid   !<
 
     REAL(wp), INTENT(IN), DIMENSION(:,:), POINTER           ::  array    !<
     REAL(wp), INTENT(IN), DIMENSION(:,:), POINTER, OPTIONAL ::  array_2  !<
 
-    INTEGER               ::  nrdims      !<
-    INTEGER, DIMENSION(4) ::  dims        !<
+    INTEGER(iwp)               ::  nrdims      !<
+    INTEGER(iwp), DIMENSION(4) ::  dims        !<
     TYPE(C_PTR)           ::  array_adr   !<
     TYPE(C_PTR)           ::  second_adr  !<
@@ -369,5 +377,5 @@
     IF ( PRESENT( array_2 ) )  THEN
        second_adr = C_LOC(array_2)
-       CALL pmc_s_setarray( childid, nrdims, dims, array_adr,                   &
+       CALL pmc_s_setarray( childid, nrdims, dims, array_adr,                  &
                             second_adr = second_adr)
     ELSE
@@ -377,4 +385,26 @@
  END SUBROUTINE pmc_s_set_dataarray_2d
 
+ SUBROUTINE pmc_s_set_dataarray_ip2d( childid, array )
+
+    IMPLICIT NONE
+
+    INTEGER(iwp),INTENT(IN) ::  childid   !<
+
+    INTEGER(idp), INTENT(IN), DIMENSION(:,:), POINTER           ::  array    !<
+
+    INTEGER(iwp)               ::  nrdims      !<
+    INTEGER(iwp), DIMENSION(4) ::  dims        !<
+    TYPE(C_PTR)           ::  array_adr   !<
+
+
+    dims      = 1
+    nrdims    = 2
+    dims(1)   = SIZE( array,1 )
+    dims(2)   = SIZE( array,2 )
+    array_adr = C_LOC( array )
+
+    CALL pmc_s_setarray( childid, nrdims, dims, array_adr , dimkey=22)
+
+ END SUBROUTINE pmc_s_set_dataarray_ip2d
 
 
@@ -383,20 +413,16 @@
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN) ::  childid   !<
-    INTEGER, INTENT(IN) ::  nz        !<
-    INTEGER, INTENT(IN) ::  nz_cl     !<
+    INTEGER(iwp), INTENT(IN) ::  childid   !<
+    INTEGER(iwp), INTENT(IN) ::  nz        !<
+    INTEGER(iwp), INTENT(IN) ::  nz_cl     !<
 
     REAL(wp), INTENT(IN), DIMENSION(:,:,:), POINTER           ::  array    !<
     REAL(wp), INTENT(IN), DIMENSION(:,:,:), POINTER, OPTIONAL ::  array_2  !<
 
-    INTEGER               ::  nrdims      !<
-    INTEGER, DIMENSION(4) ::  dims        !<
+    INTEGER(iwp)               ::  nrdims      !<
+    INTEGER(iwp), DIMENSION(4) ::  dims        !<
     TYPE(C_PTR)           ::  array_adr   !<
     TYPE(C_PTR)           ::  second_adr  !<
 
-!
-!-- TODO: the next assignment seems to be obsolete. Please check!
-    dims      = 1
-    dims      = 0
     nrdims    = 3
     dims(1)   = SIZE( array,1 )
@@ -411,5 +437,5 @@
     IF ( PRESENT( array_2 ) )  THEN
       second_adr = C_LOC( array_2 )
-      CALL pmc_s_setarray( childid, nrdims, dims, array_adr,                    &
+      CALL pmc_s_setarray( childid, nrdims, dims, array_adr,                   &
                            second_adr = second_adr)
     ELSE
@@ -423,5 +449,5 @@
  SUBROUTINE pmc_s_setind_and_allocmem( childid )
 
-    USE control_parameters,                                                     &
+    USE control_parameters,                                                    &
         ONLY:  message_string
 
@@ -433,19 +459,19 @@
 !--                                     send -> parent to child transfer
 !--                                     recv -> child to parent transfer
-    INTEGER, INTENT(IN) ::  childid   !<
-
-    INTEGER                        ::  arlen    !<
-    INTEGER                        ::  i        !<
-    INTEGER                        ::  ierr     !<
-    INTEGER                        ::  istat    !<
-    INTEGER                        ::  j        !<
-    INTEGER                        ::  myindex  !<
-    INTEGER                        ::  rcount   !< count MPI requests
-    INTEGER                        ::  tag      !<
+    INTEGER(iwp), INTENT(IN) ::  childid   !<
+
+    INTEGER(iwp)                   ::  arlen    !<
+    INTEGER(iwp)                   ::  i        !<
+    INTEGER(iwp)                   ::  ierr     !<
+    INTEGER(iwp)                   ::  istat    !<
+    INTEGER(iwp)                   ::  j        !<
+    INTEGER(iwp)                   ::  myindex  !<
+    INTEGER(iwp)                   ::  rcount   !< count MPI requests
+    INTEGER(iwp)                   ::  tag      !<
 
     INTEGER(idp)                   ::  bufsize  !< size of MPI data window
     INTEGER(KIND=MPI_ADDRESS_KIND) ::  winsize  !<
 
-    INTEGER, DIMENSION(1024)       ::  req      !<
+    INTEGER(iwp), DIMENSION(1024)       ::  req      !<
 
     TYPE(C_PTR)             ::  base_ptr  !<
@@ -482,9 +508,9 @@
           tag    = tag + 1
           rcount = rcount + 1
-          CALL MPI_ISEND( myindex, 1, MPI_INTEGER, i-1, tag,                    &
+          CALL MPI_ISEND( myindex, 1, MPI_INTEGER, i-1, tag,                   &
                           children(childid)%inter_comm, req(rcount), ierr )
 !
-!--       Maximum of 1024 outstanding requests
-!--       TODO: what does this limit mean? Does outstanding mean pending?
+!--       Maximum of 1024 pending requests
+
           IF ( rcount == 1024 )  THEN
              CALL MPI_WAITALL( rcount, req, MPI_STATUSES_IGNORE, ierr )
@@ -515,6 +541,6 @@
 
     winsize = bufsize * wp
-    CALL MPI_WIN_CREATE( base_array_pc, winsize, wp, MPI_INFO_NULL,             &
-                         children(childid)%intra_comm,                          &
+    CALL MPI_WIN_CREATE( base_array_pc, winsize, wp, MPI_INFO_NULL,            &
+                         children(childid)%intra_comm,                         &
                          children(childid)%win_parent_child, ierr )
 !
@@ -533,7 +559,7 @@
 
           IF ( ar%sendindex + ar%sendsize > bufsize )  THEN             
-             WRITE( message_string, '(a,i4,4i7,1x,a)' )                         &
-                    'parent buffer too small ',i,                               &
-                    ar%sendindex,ar%sendsize,ar%sendindex+ar%sendsize,          &
+             WRITE( message_string, '(a,i4,4i7,1x,a)' )                        &
+                    'parent buffer too small ',i,                              &
+                    ar%sendindex,ar%sendsize,ar%sendindex+ar%sendsize,         &
                     bufsize,trim(ar%name)
              CALL message( 'pmc_s_setind_and_allocmem', 'PA0429', 3, 2, 0, 6, 0 )
@@ -554,5 +580,5 @@
 !--       Receive index from child
           tag = tag + 1
-          CALL MPI_RECV( myindex, 1, MPI_INTEGER, i-1, tag,                     &
+          CALL MPI_RECV( myindex, 1, MPI_INTEGER, i-1, tag,                    &
                          children(childid)%inter_comm, MPI_STATUS_IGNORE, ierr )
           IF ( ar%nrdims == 3 )  THEN
@@ -586,20 +612,24 @@
 
 
- SUBROUTINE pmc_s_fillbuffer( childid, waittime )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)             ::  childid   !<
+ SUBROUTINE pmc_s_fillbuffer( childid, waittime, particle_transfer )
+
+    IMPLICIT NONE
+
+    INTEGER(iwp), INTENT(IN)             ::  childid   !<
 
     REAL(wp), INTENT(OUT), OPTIONAL ::  waittime  !<
-
-    INTEGER               ::  ierr     !<
-    INTEGER               ::  ij       !<
-    INTEGER               ::  ip       !<
-    INTEGER               ::  istat    !<
-    INTEGER               ::  j        !<
-    INTEGER               ::  myindex  !<
-
-    INTEGER, DIMENSION(1) ::  buf_shape
+    LOGICAL, INTENT(IN), OPTIONAL   ::  particle_transfer  !<
+
+
+    INTEGER(iwp)               ::  ierr     !<
+    INTEGER(iwp)               ::  ij       !<
+    INTEGER(iwp)               ::  ip       !<
+    INTEGER(iwp)               ::  istat    !<
+    INTEGER(iwp)               ::  j        !<
+    INTEGER(iwp)               ::  myindex  !<
+    
+    LOGICAL                    ::  lo_ptrans
+
+    INTEGER(iwp), DIMENSION(1) ::  buf_shape
 
     REAL(wp)                            ::  t1       !<
@@ -608,4 +638,6 @@
     REAL(wp), POINTER, DIMENSION(:,:)   ::  data_2d  !<
     REAL(wp), POINTER, DIMENSION(:,:,:) ::  data_3d  !<
+    INTEGER(idp), POINTER, DIMENSION(:)     ::  ibuf      !<
+    INTEGER(idp), POINTER, DIMENSION(:,:)   ::  idata_2d  !<
 
     TYPE(pedef), POINTER    ::  ape  !<
@@ -625,4 +657,7 @@
     ENDIF
 
+    lo_ptrans = .FALSE.
+    IF ( PRESENT( particle_transfer))    lo_ptrans = particle_transfer
+
     DO  ip = 1, children(childid)%inter_npes
        ape => children(childid)%pes(ip)
@@ -630,5 +665,7 @@
           ar => ape%array_list(j)
           myindex = 1
-          IF ( ar%nrdims == 2 )  THEN
+
+          IF ( ar%dimkey == 2 .AND. .NOT.lo_ptrans  )  THEN                            ! PALM 2D REAL*8 Array
+
              buf_shape(1) = ape%nrele
              CALL C_F_POINTER( ar%sendbuf, buf, buf_shape )
@@ -638,5 +675,7 @@
                 myindex = myindex + 1
              ENDDO
-          ELSEIF ( ar%nrdims == 3 )  THEN
+
+          ELSEIF ( ar%dimkey == 3  .AND. .NOT.lo_ptrans  )  THEN                       ! PALM 3D REAL*8 Array
+
              buf_shape(1) = ape%nrele*ar%a_dim(4)
              CALL C_F_POINTER( ar%sendbuf, buf, buf_shape )
@@ -647,4 +686,13 @@
                 myindex = myindex + ar%a_dim(4)
              ENDDO
+          ELSEIF ( ar%dimkey == 22 .AND. lo_ptrans  )  THEN                           ! 2D INTEGER*8 Array for particle Transfer
+
+             buf_shape(1) = ape%nrele
+             CALL C_F_POINTER( ar%sendbuf, ibuf, buf_shape )
+             CALL C_F_POINTER( ar%data, idata_2d, ar%a_dim(1:2) )
+             DO  ij = 1, ape%nrele
+                ibuf(myindex) = idata_2d(ape%locind(ij)%j,ape%locind(ij)%i)
+                myindex = myindex + 1
+             ENDDO
           ENDIF
         ENDDO
@@ -658,46 +706,65 @@
 
 
- SUBROUTINE pmc_s_getdata_from_buffer( childid, waittime )
-
-    IMPLICIT NONE
-
-    INTEGER, INTENT(IN)             ::  childid      !<
+ SUBROUTINE pmc_s_getdata_from_buffer( childid, waittime , particle_transfer, child_process_nr )
+
+    IMPLICIT NONE
+
+    INTEGER(iwp), INTENT(IN)             ::  childid      !<
     REAL(wp), INTENT(OUT), OPTIONAL ::  waittime     !<
-
-    INTEGER                        ::  ierr          !<
-    INTEGER                        ::  ij            !<
-    INTEGER                        ::  ip            !<
-    INTEGER                        ::  istat         !<
-    INTEGER                        ::  j             !<
-    INTEGER                        ::  myindex       !<
-    INTEGER                        ::  nr            !<
-    INTEGER                        ::  target_pe     !<
+    LOGICAL, INTENT(IN), OPTIONAL   ::  particle_transfer     !<
+    INTEGER(iwp), INTENT(IN), OPTIONAL   ::  child_process_nr      !<
+
+    INTEGER(iwp)                        ::  ierr          !<
+    INTEGER(iwp)                   ::  ij            !<
+    INTEGER(iwp)                   ::  ip            !<
+    INTEGER(iwp)                   ::  ip_start      !<
+    INTEGER(iwp)                   ::  ip_end        !<
+    INTEGER(iwp)                   ::  istat         !<
+    INTEGER(iwp)                   ::  j             !<
+    INTEGER(iwp)                   ::  myindex       !<
+    INTEGER(iwp)                   ::  nr            !<
+    INTEGER(iwp)                   ::  target_pe     !<
     INTEGER(kind=MPI_ADDRESS_KIND) ::  target_disp   !<
-
-    INTEGER, DIMENSION(1)          ::  buf_shape     !<
-
-    REAL(wp)                            ::  t1       !<
-    REAL(wp)                            ::  t2       !<
-    REAL(wp), POINTER, DIMENSION(:)     ::  buf      !<
-    REAL(wp), POINTER, DIMENSION(:,:)   ::  data_2d  !<
-    REAL(wp), POINTER, DIMENSION(:,:,:) ::  data_3d  !<
-
-    TYPE(pedef), POINTER    ::  ape  !<
-    TYPE(arraydef), POINTER ::  ar   !<
+    
+    LOGICAL                        ::  lo_ptrans
+
+    INTEGER(iwp), DIMENSION(1)          ::  buf_shape     !<
+
+    REAL(wp)                                ::  t1       !<
+    REAL(wp)                                ::  t2       !<
+    REAL(wp), POINTER, DIMENSION(:)         ::  buf      !<
+    REAL(wp), POINTER, DIMENSION(:,:)       ::  data_2d  !<
+    REAL(wp), POINTER, DIMENSION(:,:,:)     ::  data_3d  !<
+    INTEGER(idp), POINTER, DIMENSION(:)     ::  ibuf      !<
+    INTEGER(idp), POINTER, DIMENSION(:,:)   ::  idata_2d  !<
+
+    TYPE(pedef), POINTER                    ::  ape  !<
+    TYPE(arraydef), POINTER                 ::  ar   !<
 
 
     t1 = pmc_time()
-!
-!-- Wait for child to fill buffer
-    CALL MPI_BARRIER( children(childid)%intra_comm, ierr )
-    t2 = pmc_time() - t1
-    IF ( PRESENT( waittime ) )  waittime = t2
-!
-!-- TODO: check next statement
-!-- Fence might do it, test later
-!-- CALL MPI_WIN_FENCE( 0, children(childid)%win_parent_child, ierr)
-    CALL MPI_BARRIER( children(childid)%intra_comm, ierr )
-
-    DO  ip = 1, children(childid)%inter_npes
+
+    IF(PRESENT(child_process_nr)) then
+       ip_start = child_process_nr
+       ip_end   = child_process_nr
+    ELSE
+       ip_start = 1
+       ip_end   = children(childid)%inter_npes
+    END IF
+
+    lo_ptrans = .FALSE.
+    IF ( PRESENT( particle_transfer))    lo_ptrans = particle_transfer
+
+    IF(ip_start == 1)   THEN
+!
+!--    Wait for child to fill buffer
+       CALL MPI_BARRIER( children(childid)%intra_comm, ierr )
+       t2 = pmc_time() - t1
+       IF ( PRESENT( waittime ) )  waittime = t2
+
+       CALL MPI_BARRIER( children(childid)%intra_comm, ierr )
+    ENDIF
+
+    DO  ip = ip_start,ip_end
        ape => children(childid)%pes(ip)
        DO  j = 1, ape%nr_arrays
@@ -706,11 +773,20 @@
           IF ( ar%recvindex < 0 )  CYCLE
 
-          IF ( ar%nrdims == 2 )  THEN
+          IF ( ar%dimkey == 2  .AND. .NOT.lo_ptrans  )  THEN
              nr = ape%nrele
-          ELSEIF ( ar%nrdims == 3 )  THEN
+          ELSEIF ( ar%dimkey == 3  .AND. .NOT.lo_ptrans  )  THEN
              nr = ape%nrele * ar%a_dim(4)
+          ELSE IF ( ar%dimkey == 22 .AND. lo_ptrans)  THEN
+             nr = ape%nrele
+          ELSE
+             CYCLE                                        !particle array are not transfered here
           ENDIF
           buf_shape(1) = nr
-          CALL C_F_POINTER( ar%recvbuf, buf, buf_shape )
+          IF(lo_ptrans)   THEN
+             CALL C_F_POINTER( ar%recvbuf, ibuf, buf_shape )
+          ELSE
+             CALL C_F_POINTER( ar%recvbuf, buf, buf_shape )
+          ENDIF
+
 !
 !--       MPI passive target RMA
@@ -720,13 +796,19 @@
 !--          Child processes are located behind parent process
              target_pe = ip - 1 + m_model_npes
-             CALL MPI_WIN_LOCK( MPI_LOCK_SHARED, target_pe, 0,                  &
+             CALL MPI_WIN_LOCK( MPI_LOCK_SHARED, target_pe, 0,                      &
                                 children(childid)%win_parent_child, ierr )
-             CALL MPI_GET( buf, nr, MPI_REAL, target_pe, target_disp, nr,       &
-                           MPI_REAL, children(childid)%win_parent_child, ierr )
-             CALL MPI_WIN_UNLOCK( target_pe,                                    &
+             IF(lo_ptrans)   THEN
+                CALL MPI_GET( ibuf, nr*8, MPI_BYTE, target_pe, target_disp, nr*8,    &              !There is no MPI_INTEGER8 datatype
+                              MPI_BYTE, children(childid)%win_parent_child, ierr )
+             ELSE
+                CALL MPI_GET( buf, nr, MPI_REAL, target_pe, target_disp, nr,        &
+                              MPI_REAL, children(childid)%win_parent_child, ierr )
+             ENDIF
+             CALL MPI_WIN_UNLOCK( target_pe,                                        &
                                   children(childid)%win_parent_child, ierr )
           ENDIF
           myindex = 1
-          IF ( ar%nrdims == 2 )  THEN
+          IF ( ar%dimkey == 2  .AND. .NOT.lo_ptrans  )  THEN
+
              CALL C_F_POINTER( ar%data, data_2d, ar%a_dim(1:2) )
              DO  ij = 1, ape%nrele
@@ -734,11 +816,22 @@
                 myindex = myindex + 1
              ENDDO
-          ELSEIF ( ar%nrdims == 3 )  THEN
+
+          ELSEIF ( ar%dimkey == 3  .AND. .NOT.lo_ptrans  )  THEN
+
              CALL C_F_POINTER( ar%data, data_3d, ar%a_dim(1:3))
              DO  ij = 1, ape%nrele
-                data_3d(1:ar%a_dim(4),ape%locind(ij)%j,ape%locind(ij)%i) =      &
+                data_3d(1:ar%a_dim(4),ape%locind(ij)%j,ape%locind(ij)%i) =     &
                                               buf(myindex:myindex+ar%a_dim(4)-1)
                 myindex = myindex + ar%a_dim(4)
              ENDDO
+
+          ELSE IF ( ar%dimkey == 22 .AND. lo_ptrans)  THEN
+
+             CALL C_F_POINTER( ar%data, idata_2d, ar%a_dim(1:2) )
+             DO  ij = 1, ape%nrele
+                idata_2d(ape%locind(ij)%j,ape%locind(ij)%i) = ibuf(myindex)
+                myindex = myindex + 1
+             ENDDO
+
           ENDIF
        ENDDO
@@ -755,5 +848,5 @@
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN) ::  childid  !<
+    INTEGER(iwp), INTENT(IN) ::  childid  !<
 
     TYPE(da_namedef) ::  myname  !<
@@ -767,5 +860,5 @@
        CALL pmc_bcast( myname%nameonchild,  0, comm=m_to_child_comm(childid) )
 
-       CALL pmc_g_setname( children(childid), myname%couple_index,              &
+       CALL pmc_g_setname( children(childid), myname%couple_index,             &
                            myname%nameonparent )
    ENDDO
@@ -775,5 +868,5 @@
 
 
- SUBROUTINE pmc_s_setarray(childid, nrdims, dims, array_adr, second_adr )
+ SUBROUTINE pmc_s_setarray(childid, nrdims, dims, array_adr, second_adr, dimkey )
 
 !
@@ -781,12 +874,13 @@
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN)               ::  childid    !<
-    INTEGER, INTENT(IN)               ::  nrdims     !<
-    INTEGER, INTENT(IN), DIMENSION(:) ::  dims       !<
-
-    TYPE(C_PTR), INTENT(IN)           :: array_adr   !<
-    TYPE(C_PTR), INTENT(IN), OPTIONAL :: second_adr  !<
-
-    INTEGER ::  i  !< local counter
+    INTEGER(iwp), INTENT(IN)               :: childid    !<
+    INTEGER(iwp), INTENT(IN)               :: nrdims     !<
+    INTEGER(iwp), INTENT(IN), DIMENSION(:) :: dims       !<
+
+    TYPE(C_PTR), INTENT(IN)           :: array_adr  !<
+    TYPE(C_PTR), INTENT(IN), OPTIONAL :: second_adr !<
+    INTEGER(iwp), INTENT(IN), OPTIONAL     :: dimkey     !<
+
+    INTEGER(iwp) ::  i  !< local counter
 
     TYPE(pedef), POINTER    ::  ape  !<
@@ -798,4 +892,6 @@
        ar  => ape%array_list(next_array_in_list)
        ar%nrdims = nrdims
+       ar%dimkey = nrdims
+       IF(PRESENT(dimkey)) ar%dimkey = dimkey
        ar%a_dim  = dims
        ar%data   = array_adr
@@ -817,10 +913,10 @@
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN) ::  childid   !<
-    INTEGER, INTENT(IN) ::  iactive   !<
-
-    INTEGER :: i   !<
-    INTEGER :: ip  !<
-    INTEGER :: j   !<
+    INTEGER(iwp), INTENT(IN) ::  childid   !<
+    INTEGER(iwp), INTENT(IN) ::  iactive   !<
+
+    INTEGER(iwp) :: i   !<
+    INTEGER(iwp) :: ip  !<
+    INTEGER(iwp) :: j   !<
 
     TYPE(pedef), POINTER    ::  ape  !<
@@ -831,4 +927,5 @@
        DO  j = 1, ape%nr_arrays
           ar => ape%array_list(j)
+          if(mod(ar%dimkey,10) == 2) CYCLE           !Not for 2D array
           IF ( iactive == 1  .OR.  iactive == 2 )  THEN
              ar%data = ar%po_data(iactive)
@@ -839,4 +936,13 @@
  END SUBROUTINE pmc_s_set_active_data_array
 
+ INTEGER FUNCTION pmc_s_get_child_npes (child_id)
+   IMPLICIT NONE
+
+   INTEGER(iwp),INTENT(IN)                 :: child_id
+
+   pmc_s_get_child_npes = children(child_id)%inter_npes
+
+   RETURN
+ END FUNCTION pmc_s_get_child_npes
 
 
@@ -845,24 +951,24 @@
     IMPLICIT NONE
 
-    INTEGER, INTENT(IN)                 ::  childid     !<
-    INTEGER, INTENT(IN), DIMENSION(:,:) ::  index_list  !<
-    INTEGER, INTENT(IN)                 ::  nrp         !<
+    INTEGER(iwp), INTENT(IN)                 ::  childid     !<
+    INTEGER(iwp), INTENT(IN), DIMENSION(:,:) ::  index_list  !<
+    INTEGER(iwp), INTENT(IN)                 ::  nrp         !<
 
     TYPE(childdef), INTENT(INOUT)       ::  mychild     !<
 
-    INTEGER                                 :: i        !<
-    INTEGER                                 :: ierr     !<
-    INTEGER                                 :: ind      !<
-    INTEGER                                 :: indwin   !<
-    INTEGER                                 :: indwin2  !<
-    INTEGER                                 :: i2       !<
-    INTEGER                                 :: j        !<
-    INTEGER                                 :: rempe    !<
+    INTEGER(iwp)                            :: i        !<
+    INTEGER(iwp)                            :: ierr     !<
+    INTEGER(iwp)                            :: ind      !<
+    INTEGER(iwp)                            :: indwin   !<
+    INTEGER(iwp)                            :: indwin2  !<
+    INTEGER(iwp)                            :: i2       !<
+    INTEGER(iwp)                            :: j        !<
+    INTEGER(iwp)                            :: rempe    !<
     INTEGER(KIND=MPI_ADDRESS_KIND)          :: winsize  !<
 
-    INTEGER, DIMENSION(mychild%inter_npes)  :: remind   !<
-
-    INTEGER, DIMENSION(:), POINTER          :: remindw  !<
-    INTEGER, DIMENSION(:), POINTER          :: rldef    !<
+    INTEGER(iwp), DIMENSION(mychild%inter_npes)  :: remind   !<
+
+    INTEGER(iwp), DIMENSION(:), POINTER          :: remindw  !<
+    INTEGER(iwp), DIMENSION(:), POINTER          :: rldef    !<
 
     TYPE(pedef), POINTER                    :: ape      !<
@@ -906,5 +1012,5 @@
     winsize = mychild%inter_npes*c_sizeof(i)*2
 
-    CALL MPI_WIN_CREATE( rldef, winsize, iwp, MPI_INFO_NULL,                    &
+    CALL MPI_WIN_CREATE( rldef, winsize, iwp, MPI_INFO_NULL,                   &
                          mychild%intra_comm, indwin, ierr )
 !
@@ -937,5 +1043,5 @@
 
     CALL MPI_BARRIER( m_model_comm, ierr )
-    CALL MPI_WIN_CREATE( remindw, winsize*c_sizeof(i), iwp, MPI_INFO_NULL,      &
+    CALL MPI_WIN_CREATE( remindw, winsize*c_sizeof(i), iwp, MPI_INFO_NULL,     &
                          mychild%intra_comm, indwin2, ierr )
 !
